public class A implements Cloneable {
    protected int i;
    public A(int i) {
        this.i = i;
    }
    public void inc() {
        i++;
    }
    public String toString() {
        return "A(i="+i+")";
    }

    public Object clone() {
        try {
	    A a = (A) super.clone();
	    // ODER SO?
	    //A a = new A(i);
	    // NEIN! => dyn. Typ wre dann immer A (auch in der Unterklasse B!)
	    return a;
	}
	catch (CloneNotSupportedException e) {
	    throw new RuntimeException("Unmgliche Ausnahme: "+e);
	}
    }

    public static void main(String[] args) {
        A a = new A(2);
	System.out.println("a = "+a);

	A a1 = (A) a.clone();
	System.out.println("a1 = "+a1);
    }
}
