import java.util.*;

public class TestMap implements Comparable {
    int i;
    public TestMap(int i) {
        this.i = i;
    }
    public String toString() {
        return ""+i;
    }

    /*
     * notwendig fr HashMap:
     */
    public boolean equals(Object o) {
        if (o instanceof TestMap) {
	    TestMap m = (TestMap) o;
	    return i == m.i;
	}
	else
	    return false;
    }
    public int hashCode() {
        return i;
    }

    /*
     * notwendig fr TreeMap:
     */
    public int compareTo(Object o) {
        TestMap m = (TestMap) o;
	return i - m.i;
    }

    public static void main(String[] args) {
        //Map m = new HashMap();
        Map m = new TreeMap();
	m.put(new TestMap(1), "Hallo");
	m.put(new TestMap(1), "Welt");
	System.out.println("m = "+m);
    }
}
