public class Call {
    private int i;
    public Call(int i) {
        this.i = i;
    }
    public void inc() {
        i++;
    }
    public String toString() {
        return "Call(i="+i+")";
    }

    public static void method1(int x) {
        x = -1;			// Variable veraendern
    }
    public static void method2(Call c) {
        c = new Call(-1);	// Referenz veraendern
    }
    public static void method3(Call c) {
        c.inc();		// referenziertes Objekt veraendern
    }

    public static void main(String[] args) {
        int x = 2;
	method1(x);	// kann x nicht veraendern!
	System.out.println("x = "+x);

	Call c = new Call(2);
	method2(c);	// kann Referenz c nicht veraendern!
	System.out.println("c = "+c);

	c = new Call(2); // eigentlich ueberfluessig ;-)
	method3(c);	// veraendert referenziertes Objekt
	System.out.println("c = "+c);
    }
}
